#import <OpenGL/gl.h>
#import <Cocoa/Cocoa.h>

#import "Controller.h"
#import "Timer.h"

enum { OFF, CHARGING, DISCHARGING };

enum { NO_CYCLING, SINGLE_CYCLE, CONTINUOUS_CYCLING };

enum { TIME_AXIS, CHARGE_AXIS };

@interface GraphGLView : NSOpenGLView
{
	double voltageSample[10];
	double currentSample[10];
	double tempSample[10];
	int c;
	double voltage, current, temp;

	double m_voltages[100000];
	double m_currents[100000];
	double m_temps[100000];
	
    int counter;
	    
    IBOutlet Controller* m_controller;
	
	IBOutlet NSTextField* m_statusField;
	
    IBOutlet NSTextField* m_voltageField;
	IBOutlet NSTextField* m_currentField;
	
	IBOutlet NSTextField* m_ampHourInField;
	IBOutlet NSTextField* m_wattHourInField;
	IBOutlet NSTextField* m_ampHourOutField;
	IBOutlet NSTextField* m_wattHourOutField;
	
	IBOutlet NSTextField* m_temperatureField;
	
	IBOutlet NSMenuItem* m_noCyclingMenuItem;
	IBOutlet NSMenuItem* m_singleCycleMenuItem;
	IBOutlet NSMenuItem* m_continuousCyclingMenuItem;
	
	double m_ampHourIn, m_wattHourIn, m_ampHourOut, m_wattHourOut;
	
	IBOutlet NSTextView* m_log;
	IBOutlet NSTextView* m_cycleLog;
    
    NSSound* m_changeStateSound;
	NSSound* m_cycleFinishedSound;
	
	NSTimer* m_timer;
	NSTimer* m_slowTimer;
	
	Timer* m_accurateTimer;
    
    int m_state;
	int m_cycleType;
	
	double m_currentZeroPoint;
	
	BOOL m_drawGridLines;
	BOOL m_drawTempPlot;
	int m_xAxisType;
}

- (IBAction)charge:(id)sender;
- (IBAction)discharge:(id)sender;
- (IBAction)stop:(id)sender;
- (IBAction)clearGraph:(id)sender;

- (IBAction)setCycleType:(id)sender;

- (IBAction)toggleGridLines:(id)sender;
- (IBAction)toggleTempPlot:(id)sender;

- (IBAction)setXAxisType:(id)sender;

@end
